// OfsGainAdjustDlg.cpp : Cve[V t@C
//

#include <time.h>
#include "stdafx.h"
#include "OfsGainAdjust.h"
#include "OfsGainAdjustDlg.h"
#include "Fcad416.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define		OFFSET		0
#define		GAIN		1
#define		PM10		0x00
#define		PM5			0x10
#define		PM25		0x20
#define		PM125		0x30
#define		SPAN		2
#define		SingleEnd	0
#define		Differential	1
#define		STRBUFSIZE	2048
bool	Board_Open;
BYTE	memory_address , calibrate_data , Dif_Single , AnalogSpan;
int		SelectedBoard , scan_order[16], range, Stop_Flag,no_ch;
int		post_samp, InSamplingMode, Hist_Channel;
int		InputMode, ChannelNumber, StopFunc;
WORD bufptr[16];
WORD	num_board, board_no[16];
unsigned long		post_sampled, pre_sampled;
union	Ofsset_Change{
	unsigned short	OffsetVal;
	struct{
		unsigned short Offset00 : 1;
		unsigned short Offset01 : 1;
		unsigned short Offset02 : 1;
		unsigned short Offset03 : 1;
		unsigned short Offset04 : 1;
		unsigned short Offset05 : 1;
		unsigned short Offset06 : 1;
		unsigned short Offset07 : 1;
		unsigned short Offset08 : 1;
		unsigned short Offset09 : 1;
		unsigned short Offset10 : 1;
		unsigned short Offset11 : 1;
		unsigned short Offset12 : 1;
		unsigned short Offset13 : 1;
		unsigned short Offset14 : 1;
		unsigned short Offset15 : 1;
	} OffsetTags;
} OffsetChangeVariables;
union	Gain_Change{
	unsigned short	GainsetVal;
	struct{
		unsigned short Gainset00 : 1;
		unsigned short Gainset01 : 1;
		unsigned short Gainset02 : 1;
		unsigned short Gainset03 : 1;
		unsigned short Gainset04 : 1;
		unsigned short Gainset05 : 1;
		unsigned short Gainset06 : 1;
		unsigned short Gainset07 : 1;
		unsigned short Gainset08 : 1;
		unsigned short Gainset09 : 1;
		unsigned short Gainset10 : 1;
		unsigned short Gainset11 : 1;
		unsigned short Gainset12 : 1;
		unsigned short Gainset13 : 1;
		unsigned short Gainset14 : 1;
		unsigned short Gainset15 : 1;
	} GainsetTags;
} GainChangeVariables;

static int first = 1;

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COfsGainAdjustDlg _CAO

COfsGainAdjustDlg::COfsGainAdjustDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COfsGainAdjustDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COfsGainAdjustDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COfsGainAdjustDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COfsGainAdjustDlg)
	DDX_Control(pDX, IDC_EDIT49, m_ofset15);
	DDX_Control(pDX, IDC_EDIT46, m_ofset14);
	DDX_Control(pDX, IDC_EDIT43, m_ofset13);
	DDX_Control(pDX, IDC_EDIT40, m_ofset12);
	DDX_Control(pDX, IDC_EDIT37, m_ofset11);
	DDX_Control(pDX, IDC_EDIT34, m_ofset10);
	DDX_Control(pDX, IDC_EDIT31, m_ofset09);
	DDX_Control(pDX, IDC_EDIT28, m_ofset08);
	DDX_Control(pDX, IDC_EDIT25, m_ofset07);
	DDX_Control(pDX, IDC_EDIT22, m_ofset06);
	DDX_Control(pDX, IDC_EDIT19, m_ofset05);
	DDX_Control(pDX, IDC_EDIT16, m_ofset04);
	DDX_Control(pDX, IDC_EDIT13, m_ofset03);
	DDX_Control(pDX, IDC_EDIT10, m_ofset02);
	DDX_Control(pDX, IDC_EDIT7, m_ofset01);
	DDX_Control(pDX, IDC_EDIT68, m_GetSerialNumber);
	DDX_Control(pDX, IDC_EDIT48, m_gain15);
	DDX_Control(pDX, IDC_EDIT45, m_gain14);
	DDX_Control(pDX, IDC_EDIT42, m_gain13);
	DDX_Control(pDX, IDC_EDIT39, m_gain12);
	DDX_Control(pDX, IDC_EDIT36, m_gain11);
	DDX_Control(pDX, IDC_EDIT33, m_gain10);
	DDX_Control(pDX, IDC_EDIT30, m_gain09);
	DDX_Control(pDX, IDC_EDIT27, m_gain08);
	DDX_Control(pDX, IDC_EDIT24, m_gain07);
	DDX_Control(pDX, IDC_EDIT21, m_gain06);
	DDX_Control(pDX, IDC_EDIT18, m_gain05);
	DDX_Control(pDX, IDC_EDIT15, m_gain04);
	DDX_Control(pDX, IDC_EDIT12, m_gain03);
	DDX_Control(pDX, IDC_EDIT9, m_gain02);
	DDX_Control(pDX, IDC_EDIT6, m_gain01);
	DDX_Control(pDX, IDC_COMBO3, m_inputselect);
	DDX_Control(pDX, IDC_BUTTON2, m_button2);
	DDX_Control(pDX, IDC_EDIT67, m_errmessage);
	DDX_Control(pDX, IDC_EDIT66, m_mesureval);
	DDX_Control(pDX, IDC_COMBO2, m_SelectChannel);
	DDX_Control(pDX, IDC_PICT2, m_vargraph);
	DDX_Control(pDX, IDC_EDIT65, m_cal15);
	DDX_Control(pDX, IDC_EDIT64, m_cal14);
	DDX_Control(pDX, IDC_EDIT63, m_cal13);
	DDX_Control(pDX, IDC_EDIT62, m_cal12);
	DDX_Control(pDX, IDC_EDIT61, m_cal11);
	DDX_Control(pDX, IDC_EDIT60, m_cal10);
	DDX_Control(pDX, IDC_EDIT59, m_cal09);
	DDX_Control(pDX, IDC_EDIT58, m_cal08);
	DDX_Control(pDX, IDC_EDIT57, m_cal07);
	DDX_Control(pDX, IDC_EDIT56, m_cal06);
	DDX_Control(pDX, IDC_EDIT55, m_cal05);
	DDX_Control(pDX, IDC_EDIT54, m_cal04);
	DDX_Control(pDX, IDC_EDIT53, m_cal03);
	DDX_Control(pDX, IDC_EDIT52, m_cal02);
	DDX_Control(pDX, IDC_EDIT51, m_cal01);
	DDX_Control(pDX, IDC_EDIT50, m_cal00);
	DDX_Control(pDX, IDC_EDIT8, m_scanval02);
	DDX_Control(pDX, IDC_EDIT5, m_scanval01);
	DDX_Control(pDX, IDC_EDIT2, m_scanval00);
	DDX_Control(pDX, IDC_EDIT47, m_scanval15);
	DDX_Control(pDX, IDC_EDIT44, m_scanval14);
	DDX_Control(pDX, IDC_EDIT41, m_scanval13);
	DDX_Control(pDX, IDC_EDIT38, m_scanval12);
	DDX_Control(pDX, IDC_EDIT35, m_scanval11);
	DDX_Control(pDX, IDC_EDIT32, m_scanval10);
	DDX_Control(pDX, IDC_EDIT29, m_scanval09);
	DDX_Control(pDX, IDC_EDIT26, m_scanval08);
	DDX_Control(pDX, IDC_EDIT23, m_scanval07);
	DDX_Control(pDX, IDC_EDIT20, m_scanval06);
	DDX_Control(pDX, IDC_EDIT17, m_scanval05);
	DDX_Control(pDX, IDC_EDIT14, m_scanval04);
	DDX_Control(pDX, IDC_EDIT11, m_scanval03);
	DDX_Control(pDX, IDC_COMBO1, m_SelectVoltRange);
	DDX_Control(pDX, IDC_SPIN32, m_spinofs15);
	DDX_Control(pDX, IDC_SPIN31, m_spingain15);
	DDX_Control(pDX, IDC_SPIN30, m_spinofs14);
	DDX_Control(pDX, IDC_SPIN29, m_spingain14);
	DDX_Control(pDX, IDC_SPIN28, m_spinofs13);
	DDX_Control(pDX, IDC_SPIN27, m_spingain13);
	DDX_Control(pDX, IDC_SPIN26, m_spinofs12);
	DDX_Control(pDX, IDC_SPIN25, m_spingain12);
	DDX_Control(pDX, IDC_SPIN24, m_spinofs11);
	DDX_Control(pDX, IDC_SPIN23, m_spingain11);
	DDX_Control(pDX, IDC_SPIN22, m_spinofs10);
	DDX_Control(pDX, IDC_SPIN21, m_spingain10);
	DDX_Control(pDX, IDC_SPIN20, m_spinofs09);
	DDX_Control(pDX, IDC_SPIN19, m_spingain09);
	DDX_Control(pDX, IDC_SPIN18, m_spinofs08);
	DDX_Control(pDX, IDC_SPIN17, m_spingain08);
	DDX_Control(pDX, IDC_SPIN16, m_spinofs07);
	DDX_Control(pDX, IDC_SPIN15, m_spingain07);
	DDX_Control(pDX, IDC_SPIN14, m_spinofs06);
	DDX_Control(pDX, IDC_SPIN13, m_spingain06);
	DDX_Control(pDX, IDC_SPIN12, m_spinofs05);
	DDX_Control(pDX, IDC_SPIN11, m_spingain05);
	DDX_Control(pDX, IDC_SPIN10, m_spinofs04);
	DDX_Control(pDX, IDC_SPIN9, m_spingain04);
	DDX_Control(pDX, IDC_SPIN8, m_spinofs03);
	DDX_Control(pDX, IDC_SPIN7, m_spingain03);
	DDX_Control(pDX, IDC_SPIN6, m_spinofs02);
	DDX_Control(pDX, IDC_SPIN5, m_spingain02);
	DDX_Control(pDX, IDC_SPIN4, m_spinofs01);
	DDX_Control(pDX, IDC_SPIN3, m_spingain01);
	DDX_Control(pDX, IDC_SPIN1, m_spingain00);
	DDX_Control(pDX, IDC_SPIN2, m_spinofs00);
	DDX_Control(pDX, IDC_EDIT4, m_ofset00);
	DDX_Control(pDX, IDC_EDIT3, m_gain00);
	DDX_Control(pDX, IDC_EDIT1, m_messagebox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COfsGainAdjustDlg, CDialog)
	//{{AFX_MSG_MAP(COfsGainAdjustDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeEdit3)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeEdit4)
	ON_EN_CHANGE(IDC_EDIT6, OnChangeEdit6)
	ON_EN_CHANGE(IDC_EDIT7, OnChangeEdit7)
	ON_EN_CHANGE(IDC_EDIT9, OnChangeEdit9)
	ON_EN_CHANGE(IDC_EDIT10, OnChangeEdit10)
	ON_EN_CHANGE(IDC_EDIT12, OnChangeEdit12)
	ON_EN_CHANGE(IDC_EDIT13, OnChangeEdit13)
	ON_EN_CHANGE(IDC_EDIT15, OnChangeEdit15)
	ON_EN_CHANGE(IDC_EDIT16, OnChangeEdit16)
	ON_EN_CHANGE(IDC_EDIT18, OnChangeEdit18)
	ON_EN_CHANGE(IDC_EDIT19, OnChangeEdit19)
	ON_EN_CHANGE(IDC_EDIT21, OnChangeEdit21)
	ON_EN_CHANGE(IDC_EDIT22, OnChangeEdit22)
	ON_EN_CHANGE(IDC_EDIT24, OnChangeEdit24)
	ON_EN_CHANGE(IDC_EDIT25, OnChangeEdit25)
	ON_EN_CHANGE(IDC_EDIT27, OnChangeEdit27)
	ON_EN_CHANGE(IDC_EDIT28, OnChangeEdit28)
	ON_EN_CHANGE(IDC_EDIT30, OnChangeEdit30)
	ON_EN_CHANGE(IDC_EDIT31, OnChangeEdit31)
	ON_EN_CHANGE(IDC_EDIT33, OnChangeEdit33)
	ON_EN_CHANGE(IDC_EDIT34, OnChangeEdit34)
	ON_EN_CHANGE(IDC_EDIT36, OnChangeEdit36)
	ON_EN_CHANGE(IDC_EDIT37, OnChangeEdit37)
	ON_EN_CHANGE(IDC_EDIT39, OnChangeEdit39)
	ON_EN_CHANGE(IDC_EDIT40, OnChangeEdit40)
	ON_EN_CHANGE(IDC_EDIT42, OnChangeEdit42)
	ON_EN_CHANGE(IDC_EDIT43, OnChangeEdit43)
	ON_EN_CHANGE(IDC_EDIT45, OnChangeEdit45)
	ON_EN_CHANGE(IDC_EDIT46, OnChangeEdit46)
	ON_EN_CHANGE(IDC_EDIT48, OnChangeEdit48)
	ON_EN_CHANGE(IDC_EDIT49, OnChangeEdit49)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnSelchangeCombo3)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	//}}AFX_MSG_MAP
    ON_MESSAGE( WM_USER+0x1416, OnDllMsg )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COfsGainAdjustDlg bZ[W nh

BOOL COfsGainAdjustDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void COfsGainAdjustDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void COfsGainAdjustDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR COfsGainAdjustDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COfsGainAdjustDlg::OnButton1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// pjbgI[v

	int	retc;
	if(( retc = Fcad416_Open_Driver( &num_board , &board_no[0])) != 0){
		m_messagebox.SetWindowText("Fcad416s");
		Board_Open = FALSE;
		return;
	}
	else{
		Board_Open = TRUE;
		m_messagebox.SetWindowText("Fcad416");
	}
	SelectedBoard = 0;					// [^[XCb`͂O{
	retc = Fcad416_Start_Driver( m_hWnd);	//, SelectedBoard
	if(first == 1){
		first = 0;
		Stop_Flag = 0;
		m_spinofs00.SetRange(0,255);
//		m_spinofs00.SetBase(16);
		m_spingain00.SetRange(0,255);
//		m_spingain00.SetBase(16);
		m_spinofs01.SetRange(0,255);
//		m_spinofs01.SetBase(16);
		m_spingain01.SetRange(0,255);
		m_spinofs02.SetRange(0,255);
		m_spingain02.SetRange(0,255);
		m_spinofs03.SetRange(0,255);
		m_spingain03.SetRange(0,255);
		m_spinofs04.SetRange(0,255);
		m_spingain04.SetRange(0,255);
		m_spinofs05.SetRange(0,255);
		m_spingain05.SetRange(0,255);
		m_spinofs06.SetRange(0,255);
		m_spingain06.SetRange(0,255);
		m_spinofs07.SetRange(0,255);
		m_spingain07.SetRange(0,255);
		m_spinofs08.SetRange(0,255);
		m_spingain08.SetRange(0,255);
		m_spinofs09.SetRange(0,255);
		m_spingain09.SetRange(0,255);
		m_spinofs10.SetRange(0,255);
		m_spingain10.SetRange(0,255);
		m_spinofs11.SetRange(0,255);
		m_spingain11.SetRange(0,255);
		m_spinofs12.SetRange(0,255);
		m_spingain12.SetRange(0,255);
		m_spinofs13.SetRange(0,255);
		m_spingain13.SetRange(0,255);
		m_spinofs14.SetRange(0,255);
		m_spingain14.SetRange(0,255);
		m_spinofs15.SetRange(0,255);
		m_spingain15.SetRange(0,255);
		m_inputselect.SetCurSel(0);
		InputMode = SingleEnd;
		ChannelNumber = 16;
	}
	m_SelectChannel.SetCurSel(16);			// qXgOΏۂS`lɐݒ
	Hist_Channel = m_SelectChannel.GetCurSel();
	StopFunc = 0;
}

void COfsGainAdjustDlg::OnChangeEdit3() 
	// `lÕQC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString Str;
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		m_gain00.GetWindowText(Str);
		m_gain01.SetWindowText(Str);
		m_gain02.SetWindowText(Str);
		m_gain03.SetWindowText(Str);
		m_gain04.SetWindowText(Str);
		m_gain05.SetWindowText(Str);
		m_gain06.SetWindowText(Str);
		m_gain07.SetWindowText(Str);
		if (InputMode != Differential){
		m_gain08.SetWindowText(Str);
		m_gain09.SetWindowText(Str);
		m_gain10.SetWindowText(Str);
		m_gain11.SetWindowText(Str);
		m_gain12.SetWindowText(Str);
		m_gain13.SetWindowText(Str);
		m_gain14.SetWindowText(Str);
		m_gain15.SetWindowText(Str);
		}
		GainChangeVariables.GainsetTags.Gainset00 = 1;		// QCOOύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit4() 
	// `lÕItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset00 = 1;		// ItZbgOOύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit6() 
	// `lP̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset01 = 1;		// QCOPύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit7() 
	// `lP̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset01 = 1;		// ItZbgOPύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit9() 
	// `lQ̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset02 = 1;		// QCOQύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit10() 
	// `lQ̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset02 = 1;		// ItZbgOQύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit12() 
	// `lR̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset03 = 1;		// QCORύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit13() 
	// `lR̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset03 = 1;		// ItZbgORύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit15() 
	// `lS̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset04 = 1;		// QCOSύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit16() 
	// `lS̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset04 = 1;		// ItZbgOSύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit18() 
	// `lT̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset05 = 1;		// QCOTύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit19() 
	// `lT̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset05 = 1;		// ItZbgOTύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit21() 
	// `lŨQC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset06 = 1;		// QCOUύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit22() 
	// `lŨItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset06 = 1;		// ItZbgOUύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit24() 
	// `lṼQC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset07 = 1;		// QCOVύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit25() 
	// `lṼItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset07 = 1;		// ItZbgOVύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit27() 
	// `lW̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential){
		UpdateData(FALSE);
		return;
	}
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset08 = 1;		// QCOWύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit28() 
	// `lW̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset08 = 1;		// ItZbgOWύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit30() 
	// `lX̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset09 = 1;		// QCOXύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit31() 
	// `lX̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset09 = 1;		// ItZbgOXύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit33() 
	// `lPÕQC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset10 = 1;		// QCPOύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit34() 
	// `lPÕItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset10 = 1;		// ItZbgPOύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit36() 
	// `lPP̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset11 = 1;		// QCPPύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit37() 
	// `lPP̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset11 = 1;		// ItZbgPPύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit39() 
	// `lPQ̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset12 = 1;		// QCPQύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit40() 
	// `lPQ̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset12 = 1;		// ItZbgPQύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit42() 
	// `lPR̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset13 = 1;		// QCPRύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit43() 
	// `lPR̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset13 = 1;		// ItZbgPRύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit45() 
	// `lPS̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset14 = 1;		// QCPSύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit46() 
	// `lPS̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset14 = 1;		// ItZbgPSύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnChangeEdit48() 
	// `lPT̃QC𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		GainChangeVariables.GainsetTags.Gainset15 = 1;		// QCPTύX邽߂̃tO`FbN
	}
}

void COfsGainAdjustDlg::OnChangeEdit49() 
	// `lPT̃ItZbgl𒲐֐
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(first == 1)
		return;
	else if(InputMode == Differential)
		return;
	else{
		UpdateData(TRUE);
		OffsetChangeVariables.OffsetTags.Offset15 = 1;		// ItZbgPTύX邽߂̃tOZbg
	}
}

void COfsGainAdjustDlg::OnButton2()							// eXgJn
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int	retc;
	char	string[10];
	int	Mode = 1;
	OnButton6();
	if(OffsetChangeVariables.OffsetTags.Offset00){
		OffsetChangeVariables.OffsetTags.Offset00 = 0;
		calibrate_data = (BYTE)m_spinofs00.GetPos();			// VItZbgݒl擾
		memory_address = 0x80 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}													// jbgɑM
	if(OffsetChangeVariables.OffsetTags.Offset01){
		OffsetChangeVariables.OffsetTags.Offset01 = 0;
		calibrate_data = (BYTE)m_spinofs01.GetPos();
		memory_address = 0x81 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset02){
		OffsetChangeVariables.OffsetTags.Offset02 = 0;
		calibrate_data = (BYTE)m_spinofs02.GetPos();
		memory_address = 0x82 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset03){
		OffsetChangeVariables.OffsetTags.Offset03 = 0;
		calibrate_data = (BYTE)m_spinofs03.GetPos();
		memory_address = 0x83 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset04){
		OffsetChangeVariables.OffsetTags.Offset04 = 0;
		calibrate_data = (BYTE)m_spinofs04.GetPos();
		memory_address = 0x84 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset05){
		OffsetChangeVariables.OffsetTags.Offset05 = 0;
		calibrate_data = (BYTE)m_spinofs05.GetPos();
		memory_address = 0x85 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset06){
		OffsetChangeVariables.OffsetTags.Offset06 = 0;
		calibrate_data = (BYTE)m_spinofs06.GetPos();
		memory_address = 0x86 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset07){
		OffsetChangeVariables.OffsetTags.Offset07 = 0;
		calibrate_data = (BYTE)m_spinofs07.GetPos();
		memory_address = 0x87 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset08){
		OffsetChangeVariables.OffsetTags.Offset08 = 0;
		calibrate_data = (BYTE)m_spinofs08.GetPos();
		memory_address = 0x88 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset09){
		OffsetChangeVariables.OffsetTags.Offset09 = 0;
		calibrate_data = (BYTE)m_spinofs09.GetPos();
		memory_address = 0x89 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset10){
		OffsetChangeVariables.OffsetTags.Offset10 = 0;
		calibrate_data = (BYTE)m_spinofs10.GetPos();
		memory_address = 0x8a + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset11){
		OffsetChangeVariables.OffsetTags.Offset11 = 0;
		calibrate_data = (BYTE)m_spinofs11.GetPos();
		memory_address = 0x8b + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset12){
		OffsetChangeVariables.OffsetTags.Offset12 = 0;
		calibrate_data = (BYTE)m_spinofs12.GetPos();
		memory_address = 0x8c + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset13){
		OffsetChangeVariables.OffsetTags.Offset13 = 0;
		calibrate_data = (BYTE)m_spinofs13.GetPos();
		memory_address = 0x8d + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset14){
		OffsetChangeVariables.OffsetTags.Offset14 = 0;
		calibrate_data = (BYTE)m_spinofs14.GetPos();
		memory_address = 0x8e + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(OffsetChangeVariables.OffsetTags.Offset15){
		OffsetChangeVariables.OffsetTags.Offset15 = 0;
		calibrate_data = (BYTE)m_spinofs15.GetPos();
		memory_address = 0x8f + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , OFFSET);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset00){
		GainChangeVariables.GainsetTags.Gainset00 = 0;
		calibrate_data = (BYTE)m_spingain00.GetPos();
		memory_address = 0x80 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset01){
		GainChangeVariables.GainsetTags.Gainset01 = 0;
		calibrate_data = (BYTE)m_spingain01.GetPos();
		memory_address = 0x81 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset02){
		GainChangeVariables.GainsetTags.Gainset02 = 0;
		calibrate_data = (BYTE)m_spingain02.GetPos();
		memory_address = 0x82 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset03){
		GainChangeVariables.GainsetTags.Gainset03 = 0;
		calibrate_data = (BYTE)m_spingain03.GetPos();
		memory_address = 0x83 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset04){
		GainChangeVariables.GainsetTags.Gainset04 = 0;
		calibrate_data = (BYTE)m_spingain04.GetPos();
		memory_address = 0x84 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset05){
		GainChangeVariables.GainsetTags.Gainset05 = 0;
		calibrate_data = (BYTE)m_spingain05.GetPos();
		memory_address = 0x85 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset06){
		GainChangeVariables.GainsetTags.Gainset06 = 0;
		calibrate_data = (BYTE)m_spingain06.GetPos();
		memory_address = 0x86 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset07){
		GainChangeVariables.GainsetTags.Gainset07 = 0;
		calibrate_data = (BYTE)m_spingain07.GetPos();
		memory_address = 0x87 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset08){
		GainChangeVariables.GainsetTags.Gainset08 = 0;
		calibrate_data = (BYTE)m_spingain08.GetPos();
		memory_address = 0x88 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset09){
		GainChangeVariables.GainsetTags.Gainset09 = 0;
		calibrate_data = (BYTE)m_spingain09.GetPos();
		memory_address = 0x89 + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset10){
		GainChangeVariables.GainsetTags.Gainset10 = 0;
		calibrate_data = (BYTE)m_spingain10.GetPos();
		memory_address = 0x8a + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset11){
		GainChangeVariables.GainsetTags.Gainset11 = 0;
		calibrate_data = (BYTE)m_spingain11.GetPos();
		memory_address = 0x8b + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset12){
		GainChangeVariables.GainsetTags.Gainset12 = 0;
		calibrate_data = (BYTE)m_spingain12.GetPos();
		memory_address = 0x8c + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset13){
		GainChangeVariables.GainsetTags.Gainset13 = 0;
		calibrate_data = (BYTE)m_spingain13.GetPos();
		memory_address = 0x8d + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset14){
		GainChangeVariables.GainsetTags.Gainset14 = 0;
		calibrate_data = (BYTE)m_spingain14.GetPos();
		memory_address = 0x8e + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(GainChangeVariables.GainsetTags.Gainset15){
		GainChangeVariables.GainsetTags.Gainset15 = 0;
		calibrate_data = (BYTE)m_spingain15.GetPos();
		memory_address = 0x8f + Dif_Single + AnalogSpan;
		Fcad416_Set_Calibration( (WORD)SelectedBoard , memory_address , calibrate_data , GAIN);
		Sleep(2);
	}
	if(InputMode == Differential){					// ͂Ȃ㔼̓e𖳌ɂ
													// Edit26Edit49܂ł̃GfBbg{bNX𖳌
													// m_scanval08m_scanval15
													// m_cal08m_cal15̓eNAĖɂ
		m_scanval08.EnableWindow(FALSE);
		m_scanval09.EnableWindow(FALSE);
	}
	else{
	}
	post_samp = 8192;
	if((retc = Fcad416_Start_Samp( post_samp)) != 0){
		m_messagebox.SetWindowText("Sampling start fail");
		_itoa_s( retc , string , 10);
		m_errmessage.SetWindowText(string);
		return;
	}
	else{
		m_messagebox.SetWindowText("Sampling start success");
		InSamplingMode = 1;
		m_button2.SetWindowText( "In Sampling" );
	}
}

void COfsGainAdjustDlg::OnButton3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int	Mode = 0;
	Fcad416_Handring_Eeprom( (WORD)SelectedBoard , Mode);		// EEPROMe
	Stop_Flag = 1;
	Fcad416_Stop_Driver( );
}

void COfsGainAdjustDlg::OnSelchangeCombo1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int	loop;
	if (m_SelectVoltRange.GetCurSel() == 0)
		AnalogSpan = PM10;
	else if(m_SelectVoltRange.GetCurSel() == 1)
		AnalogSpan = PM5;
	else if(m_SelectVoltRange.GetCurSel() == 2)
		AnalogSpan = PM25;
	else
		AnalogSpan = PM125;
	range = AnalogSpan >> 4;
	for(loop = 0 ; loop < 16 ; loop++){
		scan_order[loop] = loop;
	}
	Fcad416_Set_SampCh( (WORD)SelectedBoard , ChannelNumber, scan_order,range);	
}

void COfsGainAdjustDlg::OnButton4() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int	Mode = 1;

	Fcad416_Handring_Eeprom( (WORD)SelectedBoard , Mode);		// EEPROMeǂݍ
		if(InputMode == SingleEnd)
			Dif_Single = 0x00;							// VOGh
		else
			Dif_Single = 0x40;							// 
		memory_address = 0x80 + Dif_Single + AnalogSpan;
			// rbgVnCɂ̂́A[hւ̐؂ւs
			// Dif_SingléAVOGh͂ƍ͂؂蕪鐔lAOOgȂVOSOgȂ獷
			// AnalogSpańA̓W؂ւ鐔lAOOgROg܂
			// Ƀ`lԍʂSrbgƂĉZăAhX肳
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs00.SetPos(calibrate_data);
		memory_address = 0x80 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain00.SetPos(calibrate_data);
		memory_address = 0x81 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs01.SetPos(calibrate_data);
		memory_address = 0x81 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain01.SetPos(calibrate_data);
		memory_address = 0x82 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs02.SetPos(calibrate_data);
		memory_address = 0x82 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain02.SetPos(calibrate_data);
		memory_address = 0x83 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs03.SetPos(calibrate_data);
		memory_address = 0x83 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain03.SetPos(calibrate_data);
		memory_address = 0x84 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs04.SetPos(calibrate_data);
		memory_address = 0x84 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain04.SetPos(calibrate_data);
		memory_address = 0x85 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs05.SetPos(calibrate_data);
		memory_address = 0x86 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain05.SetPos(calibrate_data);
		memory_address = 0x86 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs06.SetPos(calibrate_data);
		memory_address = 0x86 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain06.SetPos(calibrate_data);
		memory_address = 0x87 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
		m_spinofs07.SetPos(calibrate_data);
		memory_address = 0x87 + Dif_Single + AnalogSpan;
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
		m_spingain07.SetPos(calibrate_data);
		if(InputMode == SingleEnd){					// VOGh͂Ȃ㔼
			memory_address = 0x88 + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs08.SetPos(calibrate_data);
			memory_address = 0x88 + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain08.SetPos(calibrate_data);
			memory_address = 0x89 + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs09.SetPos(calibrate_data);
			memory_address = 0x89 + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain09.SetPos(calibrate_data);
			memory_address = 0x8a + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs10.SetPos(calibrate_data);
			memory_address = 0x8a + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain10.SetPos(calibrate_data);
			memory_address = 0x8b + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs11.SetPos(calibrate_data);
			memory_address = 0x8b + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain11.SetPos(calibrate_data);
			memory_address = 0x8c + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs12.SetPos(calibrate_data);
			memory_address = 0x8c + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain12.SetPos(calibrate_data);
			memory_address = 0x8d + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs13.SetPos(calibrate_data);
			memory_address = 0x8d + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain13.SetPos(calibrate_data);
			memory_address = 0x8e + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs14.SetPos(calibrate_data);
			memory_address = 0x8e + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain14.SetPos(calibrate_data);
			memory_address = 0x8f + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , OFFSET);
			m_spinofs15.SetPos(calibrate_data);
			memory_address = 0x8f + Dif_Single + AnalogSpan;
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_data , GAIN);
			m_spingain15.SetPos(calibrate_data);
		}
		else{										// [hȂ̂Ō㔼𖳌
			m_spinofs08.SetPos(0);
			m_spingain08.SetPos(0);
			m_spinofs09.SetPos(0);
			m_spingain09.SetPos(0);
			m_spinofs10.SetPos(0);
			m_spingain10.SetPos(0);
			m_spinofs11.SetPos(0);
			m_spingain11.SetPos(0);
			m_spinofs12.SetPos(0);
			m_spingain12.SetPos(0);
			m_spinofs13.SetPos(0);
			m_spingain13.SetPos(0);
			m_spinofs14.SetPos(0);
			m_spingain14.SetPos(0);
			m_spinofs15.SetPos(0);
			m_spingain15.SetPos(0);
		}
		OffsetChangeVariables.OffsetVal = 0;
		GainChangeVariables.GainsetVal = 0;
	Fcad416_Set_Trigger( 0, 0, 0, 80, 90, StopFunc);
	Fcad416_Set_SampCh( (WORD)SelectedBoard , ChannelNumber, scan_order, range);
	
}

void COfsGainAdjustDlg::OnButton5() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int retc, memcount, loop, outerloop, status[2], NotZero, FirstNonZero, LastNonZero;
	int	loopstart, loopdiff;
	int	HistGram[65536], tempnum[16], tempcount[16];
	int	width, hight;
	char str[STRBUFSIZE] , substr[10];
	HGLOBAL	hMEM;
	WORD	*buffer;
	// TvOlgpăqXgO\
	for (retc = 0 ; retc < 65536 ; retc++)
		HistGram[retc] = 0;
	Fcad416_Get_Status( (WORD)SelectedBoard, &post_sampled, &pre_sampled, status);
	if(post_sampled == 0)
		post_sampled = 1;
	memcount = post_sampled * no_ch;
	hMEM = VirtualAlloc(
		NULL,					// \܂̓R~bg̈
		memcount * 2,			// ̈̃TCY
		MEM_COMMIT,				// 蓖Ẵ^Cv
		PAGE_READWRITE			// ANZXی̃^Cv
	);
	buffer = (LPWORD)GlobalLock(hMEM);
	if ((retc = Fcad416_Read_DllData( (WORD)SelectedBoard, memcount / no_ch, 0, (UINT_PTR *)buffer, memcount * 2)) != 0){
		m_messagebox.SetWindowText("ReadDllData fail");
		VirtualFree( hMEM, memcount * 2, MEM_DECOMMIT);
		return;
	}
	else
		m_messagebox.SetWindowText("ReadDllData success");
	// S`l\ʃ`l\I
	if(Hist_Channel == 16){					// S`l\
		loopstart = 0;						// e`l̕ϒlvZĕ\
		loopdiff = 1;						// \m_cal00m_cal15ϐɂȂ
	}
	else{									// ʃ`l\
		loopstart = Hist_Channel;
		loopdiff = ChannelNumber;
	}
	// S`l\̏ꍇŃ`l̕ϒlvZ
	if(Hist_Channel != 16)
		;
	else{
		for(outerloop = 0 ; outerloop < ChannelNumber ; outerloop++){
			for(loop = 0 ; loop < 65536 ; loop++)
				HistGram[loop] = 0;		// ^[QbgzNA
			for(loop = outerloop ; loop < memcount ; loop += ChannelNumber){
				retc = (int)buffer[loop];
				HistGram[retc]++;
			}							// ǂݍ񂾃̓eɊYzJEgAbv
			tempnum[outerloop] = 0;			// rlݒ
			tempcount[outerloop] = 0;
			for(loop = 0 ; loop < 65536 ; loop++){
				if(tempnum[outerloop] <= HistGram[loop])
					tempcount[outerloop] = loop;
				tempnum[outerloop] = __max(tempnum[outerloop] , HistGram[loop]);
			}
		}
		_itoa_s(tempcount[0], str, 16);
		m_cal00.SetWindowText( str );
		_itoa_s(tempcount[1], str, 16);
		m_cal01.SetWindowText( str );
		_itoa_s(tempcount[2], str, 16);
		m_cal02.SetWindowText( str );
		_itoa_s(tempcount[3], str, 16);
		m_cal03.SetWindowText( str );
		_itoa_s(tempcount[4], str, 16);
		m_cal04.SetWindowText( str );
		_itoa_s(tempcount[5], str, 16);
		m_cal05.SetWindowText( str );
		_itoa_s(tempcount[6], str, 16);
		m_cal06.SetWindowText( str );
		_itoa_s(tempcount[7], str, 16);
		m_cal07.SetWindowText( str );
		if(InputMode == SingleEnd){					// VOGh͂Ȃ㔼
			_itoa_s(tempcount[8], str, 16);
			m_cal08.SetWindowText( str );
			_itoa_s(tempcount[9], str, 16);
			m_cal09.SetWindowText( str );
			_itoa_s(tempcount[10], str, 16);
			m_cal10.SetWindowText( str );
			_itoa_s(tempcount[11], str, 16);
			m_cal11.SetWindowText( str );
			_itoa_s(tempcount[12], str, 16);
			m_cal12.SetWindowText( str );
			_itoa_s(tempcount[13], str, 16);
			m_cal13.SetWindowText( str );
			_itoa_s(tempcount[14], str, 16);
			m_cal14.SetWindowText( str );
			_itoa_s(tempcount[15], str, 16);
			m_cal15.SetWindowText( str );
		}
	}
	for (loop = loopstart ; loop < memcount ; loop+=loopdiff){
		retc = (int)buffer[loop];
		HistGram[retc]++;				// ǂݍ񂾃̓eɊYzJEgAbv
	}
	NotZero = 0;
	for (loop = 0 ; loop < 65536 ; loop++){
		if (HistGram[loop] > 1)
			NotZero++;					// eQȏ̔z̗vf߂i\vf̐j
	}
	for (loop = 0 ; loop < 65536 ; loop++){
		if (HistGram[loop] > 1){
			FirstNonZero = loop;
			break;						// lŏ̂P傫vf̓Y߂
		}
	}
	for (loop = 65535 ; loop > 0 ; loop--){
		if (HistGram[loop] > 1){
			LastNonZero = loop;
			break;						// l傫ŏ̂P傫vf̓Y߂
		}
	}
	if ((LastNonZero - FirstNonZero) * 10 * 2 > STRBUFSIZE)
		LastNonZero = FirstNonZero + STRBUFSIZE / 20;

	for ( loop = 0 ; loop < STRBUFSIZE ; loop++)
		str[loop] = 0;					// z̒gNA
	for ( loop = FirstNonZero ; loop <= LastNonZero ; loop++){
		sprintf_s(substr , " %5X", loop);
		strcat_s(str, STRBUFSIZE, substr);			// eP傫vf̓Y𕶎ɕϊ
	}
	sprintf_s(substr , "\r\n");		// sR[hǉ
	strcat_s(str, STRBUFSIZE, substr);
	for ( loop = FirstNonZero ; loop <= LastNonZero ; loop++){
		sprintf_s(substr , "  %6d" , HistGram[loop] );
		strcat_s(str, STRBUFSIZE, substr);			// vf̂̂̒l𕶎ɕϊĒǉ
	}
	m_mesureval.SetWindowText( str );
	CWnd* myPICT2=GetDlgItem(IDC_PICT2);
	CClientDC myDC2(myPICT2);
	CRect myRECT2;
	myPICT2->SetWindowPos(&wndTop,80,300,260,150,SWP_SHOWWINDOW);
	myPICT2->GetClientRect(myRECT2);
	width = myRECT2.right;
	hight = myRECT2.bottom;
	myDC2.FillSolidRect(myRECT2,RGB(255,255,255));	// `GANA
//	CClientDC mypDC2(this);
	CPen my_pen1(PS_SOLID,10,RGB(255,255,255));
	CPen* oldPen = myDC2.SelectObject(&my_pen1);
	myDC2.SelectObject(oldPen);
	for (loop = 0 ; loop < NotZero ; loop++){
		myDC2.MoveTo(width * (loop + 1) / (NotZero + 1), hight - 1);					// ŏ̓_ł
		if(Hist_Channel == 16)
			myDC2.LineTo(width * (loop + 1) / (NotZero + 1), (hight - HistGram[FirstNonZero + loop] * hight / memcount));
		else
			myDC2.LineTo(width * (loop + 1) / (NotZero + 1), (hight - HistGram[FirstNonZero + loop] * hight * 16 / memcount));
	}
	VirtualFree( hMEM, memcount * 2, MEM_DECOMMIT);
}

void COfsGainAdjustDlg::OnButton6() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// Wp[^ݒ肷֐AKvȃp[^͈ȉ̂Ƃ
	int		loop, retc, multi = 1;			// W̃}`TvOȂ̂ŃTvO͂POQSʂr
											// TvONbNWʂrƂ
	int		Diff_Single;

	range = AnalogSpan >> 4;				// AnalogSpanϐEEPROMAhXpȂ̂łSrbgEVtgȂ
											// ۂ̃WݒƑΉȂ
	for(loop = 0 ; loop < ChannelNumber ; loop++){
		scan_order[loop] = loop;
	}
	no_ch = ChannelNumber;
	if(InputMode == SingleEnd)						// VOGh͂Ȃ㔼
		Diff_Single = 0;
	else
		Diff_Single = 1;
	if((retc = Fcad416_Set_Trigger( 0, 0, 0, 100, 150, StopFunc)) != 0)
		m_errmessage.SetWindowText("Set trigger error");
	if((retc = Fcad416_Set_SampCh( (WORD)SelectedBoard , no_ch, scan_order, range)) != 0)
		m_errmessage.SetWindowText("SampCH error");
	if((retc = Fcad416_Set_Clock( 0, 0, 128, 2, 0)) != 0)
		m_errmessage.SetWindowText("Set clock error");
	if((retc = Fcad416_Set_ScanSpeed( 0 , 8)) != 0)				// [hłWʂrw
		m_errmessage.SetWindowText("ScanSpeed set error");
	if((retc = Fcad416_Set_InpMode( (WORD)SelectedBoard , Diff_Single, 0)) != 0)
		m_errmessage.SetWindowText("SetInpmode error");
	Fcad416_Set_TransferSize( 23 );

}
//-------------------------------------------------------------------
//
//  DLL  Message
//
//-------------------------------------------------------------------
LRESULT COfsGainAdjustDlg::OnDllMsg( WPARAM wParam, LPARAM lParam ) 
{
	switch( lParam ){
    case 0:				// MSG_SAMP_END
    	if(wParam != 0)
    		break;
		Fcad416_Clear_Flags( (WORD)SelectedBoard, 0xff );
		InSamplingMode = 0;
		m_errmessage.SetWindowText( "wTvOI" );
		m_button2.SetWindowText( "eXgJn" );		// {^\ɖ߂
		Fcad416_Stop_Samp( );							// X^[grbĝ݂}~
		break;
    case 1:				// MSG_LOST_ERROR
		Fcad416_Stop_Samp( );
//		m_messagebox.SetWindowText( "G[tO" );
		m_errmessage.SetWindowText( "G[tO" );
		break;
	case 2:				// Wire drop
		m_errmessage.SetWindowText("P[uE");
		break;
	case 3:				// MSG_TRIGGER
		m_errmessage.SetWindowText( "Trigger Detected" );
		break;
    case 4:				// ]obt@TCYf[^擾bZ[W
		break;
	case 5:				// Oobt@ꏄbZ[W
		m_errmessage.SetWindowText( "RingBuffer wrap round" );
		break;
	case 6:				// T[rXNGXgMbZ[W
		m_errmessage.SetWindowText( "Service Request Received" );
		Fcad416_Clear_ServiceReq( (WORD)SelectedBoard );
		break;
	}
	return( 0 );
}

void COfsGainAdjustDlg::OnSelchangeCombo2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	Hist_Channel = m_SelectChannel.GetCurSel();
}

void COfsGainAdjustDlg::OnSelchangeCombo3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// ̓[hIBVOGh͂ȂOA͂ȂPϐɃZbg
	// ɓ̓`lPU͂Wɐݒ肷B
	if(m_inputselect.GetCurSel() == 0){
		InputMode = SingleEnd;
		ChannelNumber = 16;
	}
	else{
		InputMode = Differential;
		ChannelNumber = 8;
	}
}

void COfsGainAdjustDlg::OnButton7() // EEPROM̃f[^ǂݍ݃t@CCSV`ŏo͂֐
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	BYTE calibrate_offset[8][16];			// ̓[hdWA`lԍ
	BYTE calibrate_gain[8];					// ̓[hdW
	int	loop_ofs,loop_gain;
	BYTE memory_address;
	CString	str, substr;
	time_t	ltime;
	unsigned char SerialNumber[14], TimeString[26];

	if (Board_Open == FALSE){
		m_messagebox.SetWindowText("jbg");
		return;
	}

	SerialNumber[13] = 0;
	Fcad416_Get_SerialNumber( board_no[0] , SerialNumber , 13);
	for(loop_gain = 0 ; loop_gain < 8 ; loop_gain++){
		memory_address = (BYTE)(0x80 + (loop_gain << 4));
		Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_gain[loop_gain] , GAIN);
		for(loop_ofs = 0 ; loop_ofs < 16 ; loop_ofs++){
			memory_address = (BYTE)(0x80 + (loop_gain << 4) + loop_ofs);
			Fcad416_Get_Calibration( board_no[0] , memory_address , &calibrate_offset[loop_gain][loop_ofs] , OFFSET);
		}
	}

	CFileDialog myDLG( FALSE,"csv","*.csv",
		OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		"csv(*.csv)|*.csv||");
	if( myDLG.DoModal() == IDOK){
		CStdioFile fout(myDLG.GetPathName(), CFile::modeCreate
			| CFile::modeWrite);
		UpdateData(TRUE);
		// o͂e
		fout.WriteString("Fcad416 Offset and gain value\n");
		time(&ltime);
		ctime_s((char*)TimeString, 26, &ltime);
		fout.WriteString( str );						// ݎo
		strcpy_s((char*)TimeString, 26, "VAԍ");
		strcat_s((char*)TimeString, 26, (const char*)SerialNumber);
		str += ",";
		str += "\n";
		fout.WriteString(str);						// VAԍo
		// Ŏۂ̃f[^ǂݍ݂t@CtH[}bgŏo͂

		str = ",VO}10.24V,VO}5.12V,VO}2.56V,VO}1.28V,}10.24V,}5.12V,}2.56V,}1.28V\n";
		fout.WriteString(str);
		str = "QC,";
		for(loop_gain = 0 ; loop_gain < 8 ; loop_gain++){
			substr.Format("%X",calibrate_gain[loop_gain]);
			str += substr;
			if ( loop_gain < 7)
				str += ",";
		}
		str += "\n";
		fout.WriteString(str);
		str = "ItZbg\n";
		fout.WriteString(str);
		for (loop_ofs = 0 ; loop_ofs < 16 ; loop_ofs++){	// `lԍʂ̃Xgɂ
			str = "`l";
			substr.Format("%d",loop_ofs);
			str += substr;									// `lԍXg̐擪ɒǉ
			str += ",";										// f~^Yꂸ
			for(loop_gain = 0 ; loop_gain < 8 ; loop_gain++){
				substr.Format("%X",calibrate_offset[loop_gain][loop_ofs]);
				str += substr;
				if (loop_gain < 7)
					str += ",";
			}
			str += "\n";
			fout.WriteString(str);
		}
		fout.WriteString("\x1a");
		filename = myDLG.GetPathName();
		SetWindowText("VCSampleDLG " + filename);
	}
}

void COfsGainAdjustDlg::OnButton8() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eSPUVAԍiPRoCgj擾
	unsigned char SerialNumber[14];
	int	loop;
	CString str;

	Fcad416_Get_SerialNumber( board_no[0] , SerialNumber , 14);
	str = "";
	for(loop = 0 ; loop < 14 ; loop++)
		str += SerialNumber[loop];
	m_GetSerialNumber.SetWindowText( str );
}

/*void COfsGainAdjustDlg::OnButton9() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int	retc;
	unsigned char str[16];
	
	if(m_GetSerialNumber.GetWindowText((char*)str,13) == 0){
		m_messagebox.SetWindowText("܂VAԍǂݍł܂");
		return;
	}
	if ((retc = Fcad416_Set_SerialNumber( board_no[0] , str)) != 0){
		m_messagebox.SetWindowText("VAԍݎs");
		return;
	}
	else
		m_messagebox.SetWindowText("VAԍݐ");
}*/

void COfsGainAdjustDlg::OnButton10() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// {^ɁASẴItZbgl{PBAQTUɂȂ悤Ȃ
	// ZsȂB܂͂̂Ƃ͑ÔW`l̂ݑΏۂƂ
	// ChannelNumber=8Ȃ獷

	char string[6];
	int number;
	m_ofset00.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset00.SetWindowText( string );

	m_ofset01.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset01.SetWindowText( string );

	m_ofset02.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset02.SetWindowText( string );

	m_ofset03.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset03.SetWindowText( string );

	m_ofset04.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset04.SetWindowText( string );

	m_ofset05.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset05.SetWindowText( string );

	m_ofset06.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset06.SetWindowText( string );

	m_ofset07.GetWindowText( string , 3);
	number = atoi(string);
	if (number < 255)
		number++;
	_itoa_s(number, string, 10);
	m_ofset07.SetWindowText( string );

	if(ChannelNumber == 16){
		m_ofset08.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset08.SetWindowText( string );

		m_ofset09.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset09.SetWindowText( string );

		m_ofset10.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset10.SetWindowText( string );

		m_ofset11.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset11.SetWindowText( string );

		m_ofset12.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset12.SetWindowText( string );

		m_ofset13.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset13.SetWindowText( string );

		m_ofset14.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset14.SetWindowText( string );

		m_ofset15.GetWindowText( string , 3);
		number = atoi(string);
		if (number < 255)
			number++;
		_itoa_s(number, string, 10);
		m_ofset15.SetWindowText( string );
	}
}

void COfsGainAdjustDlg::OnButton11() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// {^ɁASẴItZbgl|PBAʂ|ɂȂ悤Ȃ
	// ZsȂB܂͂̂Ƃ͑ÔW`l̂ݑΏۂƂ
	// ChannelNumber=8Ȃ獷

	char string[6];
	int number;
	m_ofset00.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset00.SetWindowText( string );

	m_ofset01.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset01.SetWindowText( string );

	m_ofset02.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset02.SetWindowText( string );

	m_ofset03.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset03.SetWindowText( string );

	m_ofset04.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset04.SetWindowText( string );

	m_ofset05.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset05.SetWindowText( string );

	m_ofset06.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset06.SetWindowText( string );

	m_ofset07.GetWindowText( string , 3);
	number = atoi(string);
	if (number > 0)
		number--;
	_itoa_s(number, string, 10);
	m_ofset07.SetWindowText( string );

	if(ChannelNumber == 16){
		m_ofset08.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset08.SetWindowText( string );

		m_ofset09.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset09.SetWindowText( string );

		m_ofset10.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset10.SetWindowText( string );

		m_ofset11.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset11.SetWindowText( string );

		m_ofset12.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset12.SetWindowText( string );

		m_ofset13.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset13.SetWindowText( string );

		m_ofset14.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset14.SetWindowText( string );

		m_ofset15.GetWindowText( string , 3);
		number = atoi(string);
		if (number > 0)
			number--;
		_itoa_s(number, string, 10);
		m_ofset15.SetWindowText( string );
	}
}
